from __future__ import annotations

class ParameterGroup:
    def __init__(
        self, name: str, parent_group: ParameterGroup | None = None
    ) -> None: ...

class _BarrierGroup(ParameterGroup):
    class _BarrierLimitsGroup(ParameterGroup):
        corrections: int = ...
        growth: float = ...
        iteration: int = ...
        objrange: float = ...

    algorithm: int = ...
    colnonzeros: int = ...
    convergetol: float = ...
    crossover: int = ...
    display: int = ...
    ordering: int = ...
    qcpconvergetol: float = ...
    startalg: int = ...

    limits: _BarrierLimitsGroup = ...

class _BendersGroup(ParameterGroup):
    class _BendersTolerancesGroup(ParameterGroup):
        feasibilitycut: float = ...
        optimalitycut: float = ...

    strategy: int = ...
    workeralgorithm: int = ...

    tolerances: _BendersTolerancesGroup = ...

class _ConflictGroup(ParameterGroup):
    algorithm: int = ...
    display: int = ...

class _EmphasisGroup(ParameterGroup):
    memory: bool = ...
    mip: int = ...
    numerical: bool = ...

class _FeasoptGroup(ParameterGroup):
    mode: int = ...
    tolerance: float = ...

class _MipGroup(ParameterGroup):
    class _MipCutsGroup(ParameterGroup):
        bqp: int = ...
        cliques: int = ...
        covers: int = ...
        disjunctive: int = ...
        flowcovers: int = ...
        gomory: int = ...
        gubcovers: int = ...
        implied: int = ...
        liftproj: int = ...
        localimplied: int = ...
        mcfcut: int = ...
        mircut: int = ...
        nodecuts: int = ...
        pathcut: int = ...
        rlt: int = ...
        zerohalfcut: int = ...

    class _MipLimitsGroup(ParameterGroup):
        aggforcut: int = ...
        auxrootthreads: int = ...
        lowerobjstop: float = ...
        cutpasses: int = ...
        cutsfactor: float = ...
        eachcutlimit: int = ...
        gomorycand: int = ...
        gomorypass: int = ...
        nodes: int = ...
        populate: int = ...
        probedettime: float = ...
        probetime: float = ...
        repairtries: int = ...
        solutions: int = ...
        strongcand: int = ...
        strongit: int = ...
        treememory: float = ...
        upperobjstop: float = ...

    class _MipPolishafterGroup(ParameterGroup):
        absmipgap: float = ...
        dettime: float = ...
        mipgap: float = ...
        nodes: int = ...
        solutions: int = ...
        time: float = ...

    class _MipPoolGroup(ParameterGroup):
        absgap: float = ...
        capacity: int = ...
        intensity: int = ...
        relgap: float = ...
        replace: int = ...

    class _MipstrategyGroup(ParameterGroup):
        backtrack: float = ...
        bbinterval: int = ...
        branch: int = ...
        dive: int = ...
        file: int = ...
        fpheur: int = ...
        heuristiceffort: float = ...
        heuristicfreq: int = ...
        kappastats: int = ...
        lbheur: bool = ...
        miqcpstrat: int = ...
        nodeselect: int = ...
        order: bool = ...
        presolvenode: int = ...
        probe: int = ...
        rinsheur: int = ...
        search: int = ...
        startalgorithm: int = ...
        subalgorithm: int = ...
        variableselect: int = ...

    class _MipSubmipGroup(ParameterGroup):
        startalg: int = ...
        subalg: int = ...
        nodelimit: int = ...
        scale: int = ...

    class _MipTolerancesGroup(ParameterGroup):
        absmipgap: float = ...
        linearization: float = ...
        integrality: float = ...
        lowercutoff: float = ...
        mipgap: float = ...
        objdifference: float = ...
        relobjdifference: float = ...
        uppercutoff: float = ...

    display: int = ...
    interval: int = ...
    ordertype: int = ...

    cuts: _MipCutsGroup = ...
    limits: _MipLimitsGroup = ...
    polishafter: _MipPolishafterGroup = ...
    pool: _MipPoolGroup = ...
    strategy: _MipstrategyGroup = ...
    submip: _MipSubmipGroup = ...
    tolerances: _MipTolerancesGroup = ...

class _MultiobjectiveGroup(ParameterGroup):
    display: int = ...

class _NetworkGroup(ParameterGroup):
    class _NetworkTolerancesGroup(ParameterGroup):
        feasibility: float = ...
        optimality: float = ...

    display: int = ...
    iterations: int = ...
    netfind: int = ...
    pricing: int = ...

    tolerances: _NetworkTolerancesGroup = ...

class _OutputGroup(ParameterGroup):
    intsolfileprefix: str = ...
    mpslong: bool = ...
    writelevel: int = ...

class _PreprocessingGroup(ParameterGroup):
    aggregator: int = ...
    boundstrength: int = ...
    coeffreduce: int = ...
    dependency: int = ...
    dual: int = ...
    fill: int = ...
    folding: int = ...
    numpass: int = ...
    presolve: bool = ...
    qcpduals: int = ...
    qpmakepsd: bool = ...
    qtolin: int = ...
    reduce: int = ...
    reformulations: int = ...
    relax: int = ...
    repeatpresolve: int = ...
    sos1reform: int = ...
    sos2reform: int = ...
    symmetry: int = ...

class _ReadGroup(ParameterGroup):
    datacheck: int = ...
    fileencoding: str = ...
    scale: int = ...
    warninglimit: int = ...

class _SiftingGroup(ParameterGroup):
    algorithm: int = ...
    simplex: bool = ...
    display: int = ...
    iterations: int = ...

class _SimplexGroup(ParameterGroup):
    class _SimplexLimitsGroup(ParameterGroup):
        iterations: int = ...
        lowerobj: float = ...
        perturbation: int = ...
        singularity: int = ...
        upperobj: float = ...

    class _SimplexPerturbationGroup(ParameterGroup):
        constant: float = ...
        indicator: bool = ...

    class _SimplexTolerancesGroup(ParameterGroup):
        feasibility: float = ...
        markowitz: float = ...
        optimality: float = ...

    crash: int = ...
    dgradient: int = ...
    display: int = ...
    dynamicrows: int = ...
    pgradient: int = ...
    pricing: int = ...
    refactor: int = ...

    limits: _SimplexLimitsGroup = ...
    perturbation: _SimplexPerturbationGroup = ...
    tolerances: _SimplexTolerancesGroup = ...

class _TuneGroup(ParameterGroup):
    dettimelimit: float = ...
    display: int = ...
    measure: int = ...
    repeat: int = ...
    timelimit: float = ...

class RootParameterGroup(ParameterGroup):
    advance: int = ...
    clocktype: int = ...
    dettimelimit: float = ...
    lpmethod: int = ...
    optimalitytarget: int = ...
    parallel: int = ...
    paramdisplay: bool = ...
    qpmethod: int = ...
    randomseed: int = ...
    record: bool = ...
    solutiontype: int = ...
    threads: int = ...
    timelimit: float = ...
    workdir: str = ...
    workmem: float = ...

    barrier: _BarrierGroup = ...
    benders: _BendersGroup = ...
    conflict: _ConflictGroup = ...
    emphasis: _EmphasisGroup = ...
    feasopt: _FeasoptGroup = ...
    mip: _MipGroup = ...
    multiobjective: _MultiobjectiveGroup = ...
    network: _NetworkGroup = ...
    output: _OutputGroup = ...
    preprocessing: _PreprocessingGroup = ...
    read: _ReadGroup = ...
    sifting: _SiftingGroup = ...
    simplex: _SimplexGroup = ...
    tune: _TuneGroup = ...
